<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.6"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>HTTP: src/common.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">HTTP
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.6 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">common.h</div></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">// This file is part of the SHPP distribution.</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">// Copyright (c) 2023 Shahriar Rezghi.</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">//</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">// SHPP is free software: you can redistribute it and/or modify</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">// it under the terms of the GNU General Public License as published by</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">// the Free Software Foundation, version 3.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">//</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">// SHPP is distributed in the hope that it will be useful, but</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">// WITHOUT ANY WARRANTY; without even the implied warranty of</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">// General Public License for more details.</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">//</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">// You should have received a copy of the GNU General Public License</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">// along with SHPP. If not, see &lt;http://www.gnu.org/licenses/&gt;.</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;stdexcept&gt;</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span> </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">#define Assert(expr, msg) \</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">    if (!static_cast&lt;bool&gt;(expr)) throw std::runtime_error(msg);</span></div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="namespaceSHPP.html">   26</a></span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespaceSHPP.html">SHPP</a></div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>{</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno"><a class="line" href="structSHPP_1_1Request.html">   29</a></span><span class="keyword">struct </span><a class="code hl_struct" href="structSHPP_1_1Request.html">Request</a></div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>{</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="structSHPP_1_1Request.html#aaeb8fa5f30249002f084bc3276c5af7c">   32</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="structSHPP_1_1Request.html#aaeb8fa5f30249002f084bc3276c5af7c">major</a> = 1;</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="structSHPP_1_1Request.html#a70db49afe2a06b26c57dd8d8014526f1">   35</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="structSHPP_1_1Request.html#a70db49afe2a06b26c57dd8d8014526f1">minor</a> = 0;</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno"><a class="line" href="structSHPP_1_1Request.html#a5866a823a771e80686deeada31f7fa45">   38</a></span>    std::map&lt;std::string, std::string&gt; <a class="code hl_variable" href="structSHPP_1_1Request.html#a5866a823a771e80686deeada31f7fa45">headers</a>;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="structSHPP_1_1Request.html#aa9e9f0b695cb55c95681c4370bf5e081">   41</a></span>    std::string <a class="code hl_variable" href="structSHPP_1_1Request.html#aa9e9f0b695cb55c95681c4370bf5e081">method</a>;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span> </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno"><a class="line" href="structSHPP_1_1Request.html#a20658b656ffc8f9fea5237e23e89792e">   44</a></span>    std::string <a class="code hl_variable" href="structSHPP_1_1Request.html#a20658b656ffc8f9fea5237e23e89792e">path</a>;</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span> </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno"><a class="line" href="structSHPP_1_1Request.html#a8ba455cd557202706f313afc516ba50a">   47</a></span>    std::string <a class="code hl_variable" href="structSHPP_1_1Request.html#a8ba455cd557202706f313afc516ba50a">body</a>;</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>};</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span> </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno"><a class="line" href="structSHPP_1_1Response.html">   51</a></span><span class="keyword">struct </span><a class="code hl_struct" href="structSHPP_1_1Response.html">Response</a></div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>{</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="structSHPP_1_1Response.html#ae55886219f790bb683d03155a317cc81">   54</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="structSHPP_1_1Response.html#ae55886219f790bb683d03155a317cc81">status</a> = 200;</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="structSHPP_1_1Response.html#a189229e476bf19c5b207aabfcf1654cc">   57</a></span>    std::map&lt;std::string, std::string&gt; <a class="code hl_variable" href="structSHPP_1_1Response.html#a189229e476bf19c5b207aabfcf1654cc">headers</a>;</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno"><a class="line" href="structSHPP_1_1Response.html#a81e2000a03cc0258f9bfa29289e8b3f8">   60</a></span>    std::string <a class="code hl_variable" href="structSHPP_1_1Response.html#a81e2000a03cc0258f9bfa29289e8b3f8">body</a>;</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>};</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>}  <span class="comment">// namespace SHPP</span></div>
<div class="ttc" id="anamespaceSHPP_html"><div class="ttname"><a href="namespaceSHPP.html">SHPP</a></div><div class="ttdoc">The namespace of the library.</div><div class="ttdef"><b>Definition:</b> common.h:27</div></div>
<div class="ttc" id="astructSHPP_1_1Request_html"><div class="ttname"><a href="structSHPP_1_1Request.html">SHPP::Request</a></div><div class="ttdoc">Wrapper class of an HTTP request.</div><div class="ttdef"><b>Definition:</b> common.h:30</div></div>
<div class="ttc" id="astructSHPP_1_1Request_html_a20658b656ffc8f9fea5237e23e89792e"><div class="ttname"><a href="structSHPP_1_1Request.html#a20658b656ffc8f9fea5237e23e89792e">SHPP::Request::path</a></div><div class="ttdeci">std::string path</div><div class="ttdoc">Path of the HTTP request.</div><div class="ttdef"><b>Definition:</b> common.h:44</div></div>
<div class="ttc" id="astructSHPP_1_1Request_html_a5866a823a771e80686deeada31f7fa45"><div class="ttname"><a href="structSHPP_1_1Request.html#a5866a823a771e80686deeada31f7fa45">SHPP::Request::headers</a></div><div class="ttdeci">std::map&lt; std::string, std::string &gt; headers</div><div class="ttdoc">Mapping of the http key:value headers.</div><div class="ttdef"><b>Definition:</b> common.h:38</div></div>
<div class="ttc" id="astructSHPP_1_1Request_html_a70db49afe2a06b26c57dd8d8014526f1"><div class="ttname"><a href="structSHPP_1_1Request.html#a70db49afe2a06b26c57dd8d8014526f1">SHPP::Request::minor</a></div><div class="ttdeci">int minor</div><div class="ttdoc">Minor http version of the request.</div><div class="ttdef"><b>Definition:</b> common.h:35</div></div>
<div class="ttc" id="astructSHPP_1_1Request_html_a8ba455cd557202706f313afc516ba50a"><div class="ttname"><a href="structSHPP_1_1Request.html#a8ba455cd557202706f313afc516ba50a">SHPP::Request::body</a></div><div class="ttdeci">std::string body</div><div class="ttdoc">Body of the HTTP request.</div><div class="ttdef"><b>Definition:</b> common.h:47</div></div>
<div class="ttc" id="astructSHPP_1_1Request_html_aa9e9f0b695cb55c95681c4370bf5e081"><div class="ttname"><a href="structSHPP_1_1Request.html#aa9e9f0b695cb55c95681c4370bf5e081">SHPP::Request::method</a></div><div class="ttdeci">std::string method</div><div class="ttdoc">Method of the HTTP request.</div><div class="ttdef"><b>Definition:</b> common.h:41</div></div>
<div class="ttc" id="astructSHPP_1_1Request_html_aaeb8fa5f30249002f084bc3276c5af7c"><div class="ttname"><a href="structSHPP_1_1Request.html#aaeb8fa5f30249002f084bc3276c5af7c">SHPP::Request::major</a></div><div class="ttdeci">int major</div><div class="ttdoc">Major http version of the request.</div><div class="ttdef"><b>Definition:</b> common.h:32</div></div>
<div class="ttc" id="astructSHPP_1_1Response_html"><div class="ttname"><a href="structSHPP_1_1Response.html">SHPP::Response</a></div><div class="ttdoc">Wrapper class of an HTTP response.</div><div class="ttdef"><b>Definition:</b> common.h:52</div></div>
<div class="ttc" id="astructSHPP_1_1Response_html_a189229e476bf19c5b207aabfcf1654cc"><div class="ttname"><a href="structSHPP_1_1Response.html#a189229e476bf19c5b207aabfcf1654cc">SHPP::Response::headers</a></div><div class="ttdeci">std::map&lt; std::string, std::string &gt; headers</div><div class="ttdoc">Mapping of the http key:value headers.</div><div class="ttdef"><b>Definition:</b> common.h:57</div></div>
<div class="ttc" id="astructSHPP_1_1Response_html_a81e2000a03cc0258f9bfa29289e8b3f8"><div class="ttname"><a href="structSHPP_1_1Response.html#a81e2000a03cc0258f9bfa29289e8b3f8">SHPP::Response::body</a></div><div class="ttdeci">std::string body</div><div class="ttdoc">Body of the HTTP response.</div><div class="ttdef"><b>Definition:</b> common.h:60</div></div>
<div class="ttc" id="astructSHPP_1_1Response_html_ae55886219f790bb683d03155a317cc81"><div class="ttname"><a href="structSHPP_1_1Response.html#ae55886219f790bb683d03155a317cc81">SHPP::Response::status</a></div><div class="ttdeci">int status</div><div class="ttdoc">Status of the HTTP response.</div><div class="ttdef"><b>Definition:</b> common.h:54</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.6
</small></address>
</body>
</html>
